// Arena.m

#import "Arena.h"
#import <random.h>

@implementation Arena

-  resetAmountOfFood
{
  amountOfFood=0;
  return self;
}

- (int)getAmountOfFood
{
  return amountOfFood;
}

//polozi objekt tvaru kruhu, 
//color udava ci je to prekazka, jedlo..., color 64 je jedlo
- putCircleX: (int) x Y: (int) y R: (unsigned) r with:(unsigned) color
{
  int i,j,im,jm;
 
  for( i=x ; i<x+r ; i++)
    for( j=y ; j<y+r ; j++)
    {
      im = i - x;
      jm = j - y; 
      if( im*im + jm*jm <= r*r )
        {
          if(i>=0 && i<xsize && j>=0 && j<ysize)
          {
            [self putValue:color atX: i     Y: j    ];
            if(color==64)amountOfFood++;
          }

          if((2*x-i)>=0 && (2*x-i)<xsize && j>=0 && j<ysize)
          {
            [self putValue:color atX: 2*x-i Y: j    ];
            if(color==64)amountOfFood++;
          }

          if(i>=0 && i<xsize && (2*y-j)>=0 && (2*y-j)<ysize)
          {
            [self putValue:color atX: i     Y: 2*y-j];
            if(color==64)amountOfFood++;
          }

          if((2*x-i)>=0 && (2*x-i)<xsize && (2*y-j)>=0 && (2*y-j)<ysize)
          {
            [self putValue:color atX: 2*x-i Y: 2*y-j];
            if(color==64)amountOfFood++;
          }
        }
    }
  
  return self;
}


//polozi objekt tvaru stvorca, 
//color udava ci je to prekazka, jedlo...
//tazisko stvorca je na suradnici x,y
//a je strana stvorca
- putSquareX: (int) x Y: (int) y A: (unsigned) a with:(unsigned) color
{
  int i,j,r;
 
  r=a/2;

  for( i=x-r ; i<x+r ; i++)
    for( j=y-r ; j<y+r ; j++)
      if(i>=0 && i<xsize && j>=0 && j<ysize)
      { 
        [self putValue:color atX: i     Y: j    ];
        if(color==64)amountOfFood++;
      }
    
    
  
  return self;
}

//polozi objekt tvaru obdlznika, 
//color udava ci je to prekazka, jedlo...
//tazisko obdlznika je na suradnici x,y
//a,b su strany obdlznika

- putRectangleX: (int) x Y: (int) y A: (unsigned) a B: (unsigned) b with:(unsigned) color
{
  int i,j,r,s;
 
  r=a/2;
  s=b/2;


  for( i=x-r ; i<x+r ; i++)
    for( j=y-s ; j<y+s ; j++)
      if(i>=0 && i<xsize && j>=0 && j<ysize)
      {
        [self putValue:color atX: i     Y: j    ];
        if(color==64)amountOfFood++;  
      }
    
    
  
  return self;
}

@end


