
#import "FeromonSpace.h"

const FeromonValue maxFeromon=0x7fff;

//rozsirenie phero2d o pridavanie vonnych objektov do prostredia

@implementation FeromonCell

-setX:(int)theX
{
 x = theX;
 return self;
}

-setY:(int)theY
{
 y = theY;
 return self;
}

-(int)getX
{
  return x;
}

-(int)getY
{
 return y;
}
@end

@implementation FeromonSpace

//pridaj feromon, pouziva sa pri vylucovani feromunu agentom

-addFeromon:(FeromonValue) moreFeromon X:(int)x Y:(int)y
{
  FeromonValue feromonHere;

  feromonHere = [self getValueAtX: x Y: y];
  if( moreFeromon <= maxFeromon - feromonHere)
    feromonHere = feromonHere + moreFeromon ;
  else
    feromonHere = maxFeromon;

  [self putValue: feromonHere atX: x Y: y];
  return self;
}

//poloz vonavy kruh
//stred kruhu na x y, polomer R
//color je intenzita vone z intervalu <0,32768>

- putCircleX: (int) x Y: (int) y R: (unsigned) r with:(unsigned) color
{
  int i,j,im,jm;
 
  for( i=x ; i<x+r ; i++)
    for( j=y ; j<y+r ; j++)
    {
      im = i - x;
      jm = j - y; 
      if( im*im + jm*jm <= r*r )
        {
          if(i>=0 && i<xsize && j>=0 && j<ysize)
            [self addFeromon:color X: i     Y: j    ];

          if((2*x-i)>=0 && (2*x-i)<xsize && j>=0 && j<ysize)
            [self addFeromon:color X: 2*x-i Y: j    ];

          if(i>=0 && i<xsize && (2*y-j)>=0 && (2*y-j)<ysize)
            [self addFeromon:color X: i     Y: 2*y-j];

          if((2*x-i)>=0 && (2*x-i)<xsize && (2*y-j)>=0 && (2*y-j)<ysize)
          [self addFeromon:color X: 2*x-i Y: 2*y-j];
        }
    }

  [self updateLattice];    

  
  return self;
}


//poloz vonavy stvorec
//stred stvorca na x y, strana stvorca a
//color je intenzita vone z intervalu <0,32768>

- putSquareX: (int) x Y: (int) y A: (unsigned) a with:(unsigned) color
{
  int i,j,r;
 
  r=a/2;

  for( i=x-r ; i<x+r ; i++)
    for( j=y-r ; j<y+r ; j++)
      if(i>=0 && i<xsize && j>=0 && j<ysize)
        [self addFeromon:color X: i     Y: j    ];
    

  [self updateLattice];    
  
  return self;
}

//poloz vonavy obdlznik
//stred obdlznika na x y, strany stvorca a,b
//color je intenzita vone z intervalu <0,32768>
- putRectangleX: (int) x Y: (int) y A: (unsigned) a B: (unsigned) b with:(unsigned) color
{
  int i,j,r,s;
 
  r=a/2;
  s=b/2;


  for( i=x-r ; i<x+r ; i++)
    for( j=y-s ; j<y+s ; j++)
      if(i>=0 && i<xsize && j>=0 && j<ysize)    
        [self addFeromon:color X: i     Y: j    ];
    

  [self updateLattice];    
    
 
  return self;
}

//polozi vertikalnu ciaru
//x x-sova suranica
//y1,y2 okraje ciary
//color1 intenzita na jednom konci
//color2 intenzita na druhom konci
//color medzi tym je linerne zavisly, zacina s hodnotou color1 a konci
//s hodnotou color2

- putVLineX: (int) x Y1: (int) y1 Y2: (int) y2 withI1:(unsigned)color1 I2:(unsigned) color2
{
int i;
unsigned j,color;

  if(y2<y1){i=y2;y2=y1;y1=i;j=color1;color1=color2;color2=j;}  

 if(y1!=y2)
  for(i=y1;i<=y2;i++)
  { 
  if(color1<color2)
     color = color1+((i-y1)*(color2-color1))/(y2-y1);
   if(color2<color1)
     color = color1-((i-y1)*(-color2+color1))/(y2-y1);
      if(x>=0 && x<xsize && i>=0 && i<ysize)
         [self addFeromon:color X:x Y:i];
  }
  [self updateLattice];    
    
  return self;
}


//polozi vertikalnu ciaru
//x1,x2 okraje ciary
//y y-ova suradnica ciary
//color1 intenzita na jednom konci
//color2 intenzita na druhom konci
//color medzi tym je linerne zavisly, zacina s hodnotou color1 a konci
//s hodnotou color2

- putHLineX1: (int) x1 X2: (int) x2 Y: (int) y withI1:(unsigned)color1 I2:(unsigned) color2
{
int i;
unsigned j,color;

  if(x2<x1){i=x2;x2=x1;x1=i;j=color1;color1=color2;color2=j;}  

if(x2!=x1)
  for(i=x1;i<=x2;i++)
  { 
  if(color1<color2)
     color = color1+((i-x1)*(color2-color1))/(x2-x1);
   if(color2<color1)
     color = color1-((i-x1)*(-color2+color1))/(x2-x1);
   if(i>=0 && i<xsize && y>=0 && y<ysize)
     [self addFeromon:color X:i Y:y];
  }
  [self updateLattice];    
    
  return self;
}

@end