#import "Model.h"
#import <activity.h>
#import <space.h>
#import <simtools.h>
#include <random.h>
#include <gui.h>

#define SPACE 0
#define FOOD 64
#define OBSTACLE 66
#define NEST 67
#define SOIL 68
#define pS 68

@implementation Model

-getWorld
{
  return world;
}

-getWorldP0
{
  return worldP0;
}

-getWorldP1
{
  return worldP1;
}

-getWorldP2
{
  return worldP2;
}

-getWorldF
{
  return worldF;
}

-(FeromonSpace *)getFeromonP0
{
  return feromonP0;
}

-(FeromonSpace *)getFeromonP1
{
  return feromonP1;
}

-(FeromonSpace *)getFeromonP2
{
  return feromonP2;
}

-(FeromonSpace *)getFeromonF
{
  return feromonF;
}

-getArena
{
  return arena;
}

-getAntList
{
  return antList;
}

+createBegin:aZone
{
  Model *obj;
  id <ProbeMap> probeMap; 
 
  obj = [super createBegin: aZone];
  
  obj->worldX = 100;
  obj->worldY = 100;
  obj->nestX  = 10;
  obj->nestY  = 90;
  obj->diffuseConstant0 = 0.05;
  obj->evaporationRate0 = 0.99;
  obj->diffuseConstant1 = 0.10;
  obj->evaporationRate1 = 0.99;
  obj->diffuseConstant2 = 0.05;
  obj->evaporationRate2 = 0.99;
  obj->diffuseConstantF = 0.6;
  obj->evaporationRateF = 0.95;

  obj->antsNumber = 20;

  obj->filename=strdup("default.sce\0");


  probeMap = [EmptyProbeMap createBegin: aZone];
  [probeMap setProbedClass: [self class]];
  probeMap = [probeMap createEnd];

  [probeMap addProbe: [probeLibrary getProbeForVariable:"filename" inClass: [self class]]];
  [probeLibrary setProbeMap: probeMap For: [self class]];

  return obj;
}

-createEnd
{
  return [super createEnd];
}

-buildObjects
{
  Ant *anAnt;
  int xx,yy;
  id inFile;
  char aWord[10],aWord2[10];
  int N1,N2,N3,N4,N5,parse=0,subparse=0,i,j,k;
  int locX,locY,direct=0,relPhero;
  float M;
  char inside[9],brainFileName[20];


  inFile = [InFile create: globalZone withName: filename];

  if(inFile==nil)
  {
     printf("%s - No such file!\n",filename);
     return nil;
  }
  else printf("%s opened!\n\n",filename);

  [inFile getWord: aWord];
  printf("%s\n", aWord);

  if (strcmp(aWord, "Model") == 0)
    parse=1;

  while(parse==1)
  {
    [inFile getWord: aWord2];
    printf("%s ", aWord2);
    if (strcmp(aWord2, "WorldSize") == 0)
    {
      [inFile getInt: &N1];  
      [inFile getInt: &N2];  
      worldX=N1;
      worldY=N2;
      printf("%d %d\n", worldX,worldY);
    }
   else if (strcmp(aWord2, "evap0") == 0)
    {
      [inFile getFloat: &M];  
      evaporationRate0=M;
    }
    else if (strcmp(aWord2, "diff0") == 0)
    {
      [inFile getFloat: &M];  
      diffuseConstant0=M;
    }
    else if (strcmp(aWord2, "evap1") == 0)
    {
      [inFile getFloat: &M];  
      evaporationRate1=M;
    }
    else if (strcmp(aWord2, "diff1") == 0)
    {
      [inFile getFloat: &M];  
      diffuseConstant1=M;
    }
    else if (strcmp(aWord2, "evap2") == 0)
    {
      [inFile getFloat: &M];  
      evaporationRate2=M;
    }
    else if (strcmp(aWord2, "diff2") == 0)
    {
      [inFile getFloat: &M];  
      diffuseConstant2=M;
    }
    else if (strcmp(aWord2, "evapF") == 0)
    {
      [inFile getFloat: &M];  
      evaporationRateF=M;
    }
    else if (strcmp(aWord2, "diffF") == 0)
    {
      [inFile getFloat: &M];  
      diffuseConstantF=M;
    } 
    else if(strcmp(aWord2, "EndModel") == 0)
    {
      parse=2;
    }
    else 
    {
      parse=2;
      printf("error\n");
    }
  }

 
  arena = [Arena createBegin: globalZone];
  [arena setSizeX: worldX Y: worldY];
  arena = [arena createEnd];
  [arena resetAmountOfFood];

  feromonP0 = [FeromonSpace createBegin: self];
  [feromonP0 setSizeX: worldX Y: worldY];
  [feromonP0 setDiffusionConstant: diffuseConstant0];
  [feromonP0 setEvaporationRate: evaporationRate0];
  [feromonP0 setArena: arena setType: 1];
  feromonP0 = [feromonP0 createEnd];

  feromonP1 = [FeromonSpace createBegin: self];
  [feromonP1 setSizeX: worldX Y: worldY];
  [feromonP1 setDiffusionConstant: diffuseConstant1];
  [feromonP1 setEvaporationRate: evaporationRate1];
  [feromonP1 setArena: arena setType: 1];
  feromonP1 = [feromonP1 createEnd];

  feromonP2 = [FeromonSpace createBegin: self];
  [feromonP2 setSizeX: worldX Y: worldY];
  [feromonP2 setDiffusionConstant: diffuseConstant2];
  [feromonP2 setEvaporationRate: evaporationRate2];
  [feromonP2 setArena: arena setType: 1];
  feromonP2 = [feromonP2 createEnd];

  feromonF = [FeromonSpace createBegin: self];
  [feromonF setSizeX: worldX Y: worldY];
  [feromonF setDiffusionConstant: diffuseConstantF];
  [feromonF setEvaporationRate: evaporationRateF];
  [feromonF setArena: arena setType: 2];
  feromonF = [feromonF createEnd];



  if(parse==2)
  {
    [inFile getWord: aWord];
    printf("%s ", aWord);
  }
  else 
  {
      [arena putCircleX:worldX/2 Y:worldY/2 R:10 with:NEST];
      nestX=worldX/2;
      nestY=worldY/2;
  }

  if (strcmp(aWord, "Scene") == 0) parse=1;

  while(parse==1)
  {
    [inFile getWord: aWord];
    printf("%s ", aWord);

    if (strcmp(aWord, "Food") == 0)
    {
      [inFile getWord: aWord2];
      printf("%s", aWord2);
      if (strcmp(aWord2, "Circle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];
        printf(" %d %d %d\n",N1,N2,N3); 
        [arena putCircleX:N1 Y:N2 R:N3 with:FOOD];
      }
      else if (strcmp(aWord2, "Point") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        printf(" %d %d %d\n",N1,N2); 
        [arena putValue:FOOD atX:N1 Y:N2];
      }
      else if (strcmp(aWord2, "Square") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        printf(" %d %d %d\n",N1,N2,N3); 
        [arena putSquareX:N1 Y:N2 A:N3 with:FOOD];
      }
      else if (strcmp(aWord2, "Rectangle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        printf(" %d %d %d\n",N1,N2,N3,N4); 
        [arena putRectangleX:N1 Y:N2 A:N3 B:N4 with:FOOD];
      }
      else 
      {
        printf(" %s <- Parser Error\n",aWord2); 
      }
    }
    else 
    if (strcmp(aWord, "Obstacle") == 0)
    {
      [inFile getWord: aWord2];
      printf("%s", aWord2);
      if (strcmp(aWord2, "Circle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];
        printf(" %d %d %d\n",N1,N2,N3); 
        [arena putCircleX:N1 Y:N2 R:N3 with:OBSTACLE];
      }
      else if (strcmp(aWord2, "Point") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        printf(" %d %d\n",N1,N2); 
        [arena putValue:OBSTACLE atX:N1 Y:N2];
      }
      else if (strcmp(aWord2, "Square") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        printf(" %d %d %d\n",N1,N2,N3); 
        [arena putSquareX:N1 Y:N2 A:N3 with:OBSTACLE];
      }
      else if (strcmp(aWord2, "Rectangle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        printf(" %d %d %d %d\n",N1,N2,N3,N4); 
        [arena putRectangleX:N1 Y:N2 A:N3 B:N4 with:OBSTACLE];
      }
      else 
      {
        printf(" %s <- Parser Error\n",aWord2); 
      }
    }
    else
    if (strcmp(aWord, "Nest") == 0)
    {
      [inFile getWord: aWord2];
      printf("%s", aWord2);
      if (strcmp(aWord2, "Circle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];
        printf(" %d %d %d\n",N1,N2,N3); 
        [arena putCircleX:N1 Y:N2 R:N3 with:NEST];
        nestX=N1;
        nestY=N2;
        if(nestX<0 || nestX>=worldX || nestY<0 || nestY>=worldY)
        {
          parse=3;
          printf("\nNest out of Arena\nNest replacing to the center of Arena\n");
          nestX=worldX/2;
          nestY=worldY/2;
          [arena putCircleX:nestX Y:nestY R:10 with:NEST];
        }  
      }
      else if (strcmp(aWord2, "Point") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        printf(" %d %d\n",N1,N2); 
        [arena putValue:NEST atX:N1 Y:N2];
        nestX=N1;
        nestY=N2;
        if(nestX<0 || nestX>=worldX || nestY<0 || nestY>=worldY)
        {
          parse=3;
          printf("\nNest out of Arena\nNest replacing to the center of Arena\n");
          nestX=worldX/2;
          nestY=worldY/2;
          [arena putCircleX:nestX Y:nestY R:10 with:NEST];
        }  
      }
      else if (strcmp(aWord2, "Square") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        printf(" %d %d %d\n",N1,N2,N3); 
        [arena putSquareX:N1 Y:N2 A:N3 with:NEST];
        nestX=N1;
        nestY=N2;
        if(nestX<0 || nestX>=worldX || nestY<0 || nestY>=worldY)
        {
          parse=3;
          printf("\nNest out of Arena\nNest replacing to the center of Arena\n");
          nestX=worldX/2;
          nestY=worldY/2;
          [arena putCircleX:nestX Y:nestY R:10 with:NEST];
        }   
      }
      else if (strcmp(aWord2, "Rectangle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        printf(" %d %d %d %d\n",N1,N2,N3,N4); 
        [arena putRectangleX:N1 Y:N2 A:N3 B:N4 with:NEST];
        nestX=N1;
        nestY=N2;
        if(nestX<0 || nestX>=worldX || nestY<0 || nestY>=worldY)
        {
          parse=3;
          printf("\nNest out of Arena\nNest replacing to the center of Arena\n");
          nestX=worldX/2;
          nestY=worldY/2;
          [arena putCircleX:nestX Y:nestY R:10 with:NEST];
        }   
      }
      else 
      {
        printf(" %s <- Parse Error\n",aWord2); 
      }
    }
    else
    if (strcmp(aWord, "Space") == 0)
    {
      [inFile getWord: aWord2];
      printf("%s", aWord2);
      if (strcmp(aWord2, "Circle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];
        printf(" %d %d %d\n",N1,N2,N3); 
        [arena putCircleX:N1 Y:N2 R:N3 with:SPACE];
      }
      else if (strcmp(aWord2, "Point") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        printf(" %d %d\n",N1,N2); 
        [arena putValue:SPACE atX:N1 Y:N2];
      }
      else if (strcmp(aWord2, "Square") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        printf(" %d %d %d\n",N1,N2,N3); 
        [arena putSquareX:N1 Y:N2 A:N3 with:SPACE];
      }
      else if (strcmp(aWord2, "Rectangle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        printf(" %d %d %d %d\n",N1,N2,N3,N4); 
        [arena putRectangleX:N1 Y:N2 A:N3 B:N4 with:SPACE];
      }
      else 
      {
        printf(" %s <- Parser Error\n",aWord2); 
      }
    }
    else
    if (strcmp(aWord, "Pheromone0") == 0)
    {
      [inFile getWord: aWord2];
      printf("%s", aWord2);
      if (strcmp(aWord2, "Circle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];
        [inFile getInt: &N4];
        printf(" %d %d %d %d\n",N1,N2,N3,N4); 
        [feromonP0 putCircleX:N1 Y:N2 R:N3 with:N4];
      }
      else if (strcmp(aWord2, "Point") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        printf(" %d %d %d\n",N1,N2,N3); 
        [feromonP0 addFeromon:N3 X:N1 Y:N2];
        [feromonP0 updateLattice];
      }
      else if (strcmp(aWord2, "Square") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        printf(" %d %d %d %d\n",N1,N2,N3,N4); 
        [feromonP0 putSquareX:N1 Y:N2 A:N3 with:N4];
      }
      else if (strcmp(aWord2, "Rectangle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        [inFile getInt: &N5];  
        printf(" %d %d %d %d %d\n",N1,N2,N3,N4,N5); 
        [feromonP0 putRectangleX:N1 Y:N2 A:N3 B:N4 with:N5];
      }
      else if (strcmp(aWord2, "VLine") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        [inFile getInt: &N5];  
        printf(" %d %d %d %d %d\n",N1,N2,N3,N4,N5); 
        [feromonP0 putVLineX:N1 Y1:N2 Y2:N3 withI1:N4 I2:N5];
      }
      else if (strcmp(aWord2, "HLine") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        [inFile getInt: &N5];  
        printf(" %d %d %d %d %d\n",N1,N2,N3,N4,N5); 
        [feromonP0 putHLineX1:N1 X2:N2 Y:N3 withI1:N4 I2:N5];
      }
      else 
      {
        printf(" %s <- Parser Error\n",aWord2); 
      }
    }
    else
    if (strcmp(aWord, "Pheromone1") == 0)
    {
      [inFile getWord: aWord2];
      printf("%s", aWord2);
      if (strcmp(aWord2, "Circle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];
        [inFile getInt: &N4];
        printf(" %d %d %d %d\n",N1,N2,N3,N4); 
        [feromonP1 putCircleX:N1 Y:N2 R:N3 with:N4];
      }
      else if (strcmp(aWord2, "Point") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        printf(" %d %d %d\n",N1,N2,N3); 
        [feromonP1 addFeromon:N3 X:N1 Y:N2];
        [feromonP1 updateLattice];
      }
      else if (strcmp(aWord2, "Square") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        printf(" %d %d %d %d\n",N1,N2,N3,N4); 
        [feromonP1 putSquareX:N1 Y:N2 A:N3 with:N4];
      }
      else if (strcmp(aWord2, "Rectangle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        [inFile getInt: &N5];  
        printf(" %d %d %d %d %d\n",N1,N2,N3,N4,N5); 
        [feromonP1 putRectangleX:N1 Y:N2 A:N3 B:N4 with:N5];
      }
      else if (strcmp(aWord2, "VLine") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        [inFile getInt: &N5];  
        printf(" %d %d %d %d %d\n",N1,N2,N3,N4,N5); 
        [feromonP1 putVLineX:N1 Y1:N2 Y2:N3 withI1:N4 I2:N5];
      }
      else if (strcmp(aWord2, "HLine") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        [inFile getInt: &N5];  
        printf(" %d %d %d %d %d\n",N1,N2,N3,N4,N5); 
        [feromonP1 putHLineX1:N1 X2:N2 Y:N3 withI1:N4 I2:N5];
      }
      else 
      {
        printf(" %s <- Parser Error\n",aWord2); 
      }
    }
    else
    if (strcmp(aWord, "Pheromone2") == 0)
    {
      [inFile getWord: aWord2];
      printf("%s", aWord2);
      if (strcmp(aWord2, "Circle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];
        [inFile getInt: &N4];
        printf(" %d %d %d %d\n",N1,N2,N3,N4); 
        [feromonP2 putCircleX:N1 Y:N2 R:N3 with:N4];
      }
      else if (strcmp(aWord2, "Point") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        printf(" %d %d %d\n",N1,N2,N3); 
        [feromonP2 addFeromon:N3 X:N1 Y:N2];
        [feromonP2 updateLattice];
      }
      else if (strcmp(aWord2, "Square") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        printf(" %d %d %d %d\n",N1,N2,N3,N4); 
        [feromonP2 putSquareX:N1 Y:N2 A:N3 with:N4];
      }
      else if (strcmp(aWord2, "Rectangle") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        [inFile getInt: &N5];  
        printf(" %d %d %d %d %d\n",N1,N2,N3,N4,N5); 
        [feromonP2 putRectangleX:N1 Y:N2 A:N3 B:N4 with:N5];
      }
      else if (strcmp(aWord2, "VLine") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        [inFile getInt: &N5];  
        printf(" %d %d %d %d %d\n",N1,N2,N3,N4,N5); 
        [feromonP2 putVLineX:N1 Y1:N2 Y2:N3 withI1:N4 I2:N5];
      }
      else if (strcmp(aWord2, "HLine") == 0)
      {
        [inFile getInt: &N1];  
        [inFile getInt: &N2];  
        [inFile getInt: &N3];  
        [inFile getInt: &N4];  
        [inFile getInt: &N5];  
        printf(" %d %d %d %d %d\n",N1,N2,N3,N4,N5); 
        [feromonP2 putHLineX1:N1 X2:N2 Y:N3 withI1:N4 I2:N5];
      }
      else 
      {
        printf(" %s <- Parser Error\n",aWord2); 
      }
    }
    else
    if (strcmp(aWord, "EndScene") == 0)
    {  
      parse=3;
//      printf(" of creating!\n");
    }
    else
    {
      printf(" %s <- ERROR!\n",aWord);
      [arena fastFillWithValue:0];
      [arena putCircleX:worldX/2 Y:worldY/2 R:10 with:NEST];
      nestX=worldX/2;
      nestY=worldY/2;
      parse=3;
    }  
  }
 
  [feromonF setAmount: [arena getAmountOfFood]];

  world = [Grid2d createBegin: self];
  [world setSizeX: worldX Y:worldY];
  world = [world createEnd];
  [world fillWithObject: nil];

  worldP0 = [Grid2d createBegin: self];
  [worldP0 setSizeX: worldX Y:worldY];
  worldP0 = [worldP0 createEnd];
  [worldP0 fillWithObject: nil];

  worldP1 = [Grid2d createBegin: self];
  [worldP1 setSizeX: worldX Y:worldY];
  worldP1 = [worldP1 createEnd];
  [worldP1 fillWithObject: nil];

  worldP2 = [Grid2d createBegin: self];
  [worldP2 setSizeX: worldX Y:worldY];
  worldP2 = [worldP2 createEnd];
  [worldP2 fillWithObject: nil];

  worldF = [Grid2d createBegin: self];
  [worldF setSizeX: worldX Y:worldY];
  worldF = [worldF createEnd];
  [worldF fillWithObject: nil];



  antList = [List create: self];

  if(parse==2 || parse==3)
  {
    [inFile getWord: aWord];
    printf("\n%s ", aWord);
  }

  if (strcmp(aWord, "AgentSection") == 0) parse=1;

  while(parse==1)
  {
    [inFile getWord:aWord];
    printf("%s\n", aWord);

    if (strcmp(aWord, "Agent") == 0) 
    {
      subparse=1;
      antsNumber=1;
      locX=nestX;
      locY=nestY;      
      direct=0;
      relPhero=0;
      strcpy(inside,"00000000\0");
      strcpy(brainFileName,"default.brn");
    }
    else if(strcmp(aWord, "EndAgentSection") == 0)
    {
      parse=0;
      subparse=0;
      printf("\n");
    }
    else
    {
      printf("Error\n");
      parse=0;
      subparse=0;
    }

    while(subparse==1)
    {
      [inFile getWord: aWord];
      printf("%s ", aWord);

      if (strcmp(aWord, "NumbOfAgents") == 0)
      {
        [inFile getInt: &antsNumber];
        printf("%d\n",antsNumber); 
        if(antsNumber<=0)
        {
          printf("\nNo Agents\n");
          subparse=0;
        }
      }  
      else  if (strcmp(aWord, "Location") == 0)
      {
        [inFile getWord: aWord2];
        printf("%s", aWord2);
        if (strcmp(aWord2, "Nest") == 0)
        {
          locX=nestX;
          locY=nestY;
        }
        else if (strcmp(aWord2, "At") == 0)
        {
          [inFile getInt: &N1];  
          [inFile getInt: &N2];  
          locX=N1;
          locY=N2;
          printf(" %d %d\n", N1, N2);
        } 
        else if (strcmp(aWord2, "Random") == 0)
        {
          locX=[uniformIntRand getIntegerWithMin: 0 withMax: worldX-1];
          locY=[uniformIntRand getIntegerWithMin: 0 withMax: worldY-1];
        } 
      }
      else  if (strcmp(aWord, "Direct") == 0)
      {
        [inFile getWord: aWord2];
        printf("%s", aWord2);
        if (strcmp(aWord2, "N") == 0) direct=0;
        else if (strcmp(aWord2, "NE") == 0) direct=1;
        else if (strcmp(aWord2, "E") == 0) direct=2;
        else if (strcmp(aWord2, "SE") == 0) direct=3;
        else if (strcmp(aWord2, "S") == 0) direct=4;
        else if (strcmp(aWord2, "SW") == 0) direct=5;
        else if (strcmp(aWord2, "W") == 0) direct=6;
        else if (strcmp(aWord2, "NW") == 0) direct=7;
        else if (strcmp(aWord2, "Random") == 0) direct=8;
        else strcpy(aWord2,"error"); 
        printf(" %s\n",aWord2);
      }
      else  if (strcmp(aWord, "Inside") == 0)
      {
        N1=0;
        while(N1==0)
        { 
          [inFile getWord: aWord2];
          printf(" %s", aWord2);
          if (strcmp(aWord2, "Hungry") == 0) inside[0]='1';
          else if (strcmp(aWord2, "Trail-Lay") == 0) inside[1]='1';
          else if (strcmp(aWord2, "Returning") == 0) inside[2]='1';
          else if (strcmp(aWord2, "Foraging") == 0) inside[3]='1';
          else if (strcmp(aWord2, "Building") == 0) inside[4]='1';
          else if (strcmp(aWord2, "Soil") == 0) inside[6]='1';
          else if (strcmp(aWord2, "EndInside") == 0) N1=1;
          else {printf("%s <- error\n",aWord2); N1=1;subparse=0;parse=5;}
        }
      }
      else  if (strcmp(aWord, "Brain") == 0)
      {
        [inFile getWord: aWord2];
        printf("%s\n", aWord2);
        strcpy(brainFileName,aWord2);
      }  
      else  if (strcmp(aWord, "RelPhero") == 0)
      {
        [inFile getInt: &relPhero];
        printf("%d\n",relPhero); 
        if(relPhero<0 || relPhero>32000)
        {
          printf("Value of released pheromone must be in<0, 32000>\n");
          relPhero=0;
        } 
      } 
      else  if (strcmp(aWord, "EndAgent") == 0)
      {
        printf("\n");
        subparse=2;
      }   
      else 
      {
        printf(" <- error\n"); 
        subparse=0;
      } 
    }

  if(subparse==2)
  {
    subparse=0;
    for(N1=1;N1<=antsNumber;N1++)
    {
      printf("%2d-Agent at ( %d, %d) with direct=%d. Inside=%s. Brain  %s. rel %d.\n",N1,locX,locY,direct,inside,brainFileName,relPhero);

      anAnt = [Ant create: globalZone];
      [anAnt setX: locX Y: locY O:direct];
      [anAnt setNestX: nestX Y: nestY];
      [anAnt setWorldX: worldX Y: worldY];
      [anAnt setWorldA: world];
      [anAnt setRelPhero: relPhero];
      [anAnt setArena: arena];
      [anAnt setFSpace: feromonF];
      [anAnt setP0Space: feromonP0];
      [anAnt setP1Space: feromonP1];
      [anAnt setP2Space: feromonP2];
      [anAnt setInside: inside];
      [anAnt setBrain: brainFileName];
      anAnt = [anAnt createEnd];

      [antList addLast: anAnt];
    }
  } 
 } 

  [inFile drop];

  return self;
}

-buildActions
{
  modelActions = [ActionGroup create: self];
  [modelActions createActionTo: feromonP0 message:M(stepRule)];
  [modelActions createActionTo: feromonP1 message:M(stepRule)];
  [modelActions createActionTo: feromonP2 message:M(stepRule)];
  [modelActions createActionTo: feromonF message:M(stepRule)];
  [modelActions createActionForEach: antList  message: M(step)];
  [modelActions createActionTo: feromonP0 message:M(updateLattice)];
  [modelActions createActionTo: feromonP1 message:M(updateLattice)];
  [modelActions createActionTo: feromonP2 message:M(updateLattice)];
  [modelActions createActionTo: feromonF message:M(updateLattice)];


  planModelu = [Schedule createBegin: self];
  [planModelu setRepeatInterval: 1];
  planModelu = [planModelu createEnd];
  [planModelu at: 0 createAction: modelActions];


  return self;
}

- activateIn: swarmContext 
{
  [super activateIn: swarmContext];
  [planModelu activateIn: self];


  return [self getActivity];
}

@end
