#import "Observer.h"
#import "Model.h"
#import <activity.h>
#import <simtoolsgui.h>

@implementation Observer

+createBegin: aZone
{
  Observer *obj;
  id <ProbeMap> probeMap;
 
  obj = [super createBegin: aZone];
 
  obj->frDisp = 1;

  probeMap = [EmptyProbeMap createBegin: aZone];
  [probeMap setProbedClass: [self class]];
  probeMap = [probeMap createEnd];

  [probeMap addProbe: [probeLibrary getProbeForVariable:"frDisp" inClass: [self class]]];

  [probeLibrary setProbeMap: probeMap For: [self class]];
 
  return obj;
}

-createEnd
{
  return [super createEnd];
}

-buildObjects
{
  int i;

  [super buildObjects];

  model =  [Model create: globalZone];

  CREATE_PROBE_DISPLAY(model);
  CREATE_PROBE_DISPLAY(self);

  [controlPanel setStateStopped];

  [model buildObjects];

  if(model == nil)  [controlPanel setStateQuit];

  colorMap = [Colormap create: self];

  [colorMap setColor: 0 ToName:"white"];
  for( i=1 ; i<64 ; i++ )
    [colorMap setColor: i ToRed:((double)i/63.0) Green:(1-((double)i/63.0)) Blue:1];


  [colorMap setColor: 64 ToName:"red"];   // farba potravy
  [colorMap setColor: 65 ToName:"black"]; // farba mravca
  [colorMap setColor: 66 ToRed:0.7 Green:0.45 Blue:0.7]; // farba prekazky
  [colorMap setColor: 67 ToRed:0.8 Green:0.6 Blue:0.3]; // farba hniezda
  [colorMap setColor: 68 ToRed:0.3 Green:0.9 Blue:0.3]; // farba soil

  worldRaster = [ZoomRaster create: self];
  [worldRaster setColormap: colorMap];
  [worldRaster setZoomFactor: 2];
  [worldRaster setWidth:[[model getWorld] getSizeX]
                 Height:[[model getWorld] getSizeY]];
  [worldRaster setWindowTitle:"Arena"];
  [worldRaster pack];

  worldP0Raster = [ZoomRaster create: self];
  [worldP0Raster setColormap: colorMap];
  [worldP0Raster setZoomFactor: 2];
  [worldP0Raster setWidth:[[model getWorldP0] getSizeX]
                 Height:[[model getWorldP0] getSizeY]];
  [worldP0Raster setWindowTitle:"Pheromone Odor P0"];
  [worldP0Raster pack];

  worldP1Raster = [ZoomRaster create: self];
  [worldP1Raster setColormap: colorMap];
  [worldP1Raster setZoomFactor: 2];
  [worldP1Raster setWidth:[[model getWorldP1] getSizeX]
                 Height:[[model getWorldP1] getSizeY]];
  [worldP1Raster setWindowTitle:"Pheromone Odor P1"];
  [worldP1Raster pack];

  worldP2Raster = [ZoomRaster create: self];
  [worldP2Raster setColormap: colorMap];
  [worldP2Raster setZoomFactor: 2];
  [worldP2Raster setWidth:[[model getWorldP2] getSizeX]
                 Height:[[model getWorldP2] getSizeY]];
  [worldP2Raster setWindowTitle:"Pheromone Odor P2"];
  [worldP2Raster pack];

  worldFRaster = [ZoomRaster create: self];
  [worldFRaster setColormap: colorMap];
  [worldFRaster setZoomFactor: 2];
  [worldFRaster setWidth:[[model getWorldF] getSizeX]
                 Height:[[model getWorldF] getSizeY]];
  [worldFRaster setWindowTitle:"Food Odor"];
  [worldFRaster pack];



  arenaDisplay = [Value2dDisplay createBegin: self];
  [arenaDisplay setDisplayWidget: worldRaster colormap: colorMap];
  [arenaDisplay setDiscrete2dToDisplay: [model getArena]];
  arenaDisplay = [arenaDisplay createEnd];

  feromonDisplayP0 = [Value2dDisplay createBegin: self];
  [feromonDisplayP0 setDisplayWidget: worldP0Raster colormap: colorMap];
  [feromonDisplayP0 setDiscrete2dToDisplay: [model getFeromonP0]];
  [feromonDisplayP0 setDisplayMappingM: 512 C:0];
  feromonDisplayP0 = [feromonDisplayP0 createEnd];

  feromonDisplayP1 = [Value2dDisplay createBegin: self];
  [feromonDisplayP1 setDisplayWidget: worldP1Raster colormap: colorMap];
  [feromonDisplayP1 setDiscrete2dToDisplay: [model getFeromonP1]];
  [feromonDisplayP1 setDisplayMappingM: 512 C:0];
  feromonDisplayP1 = [feromonDisplayP1 createEnd];

  feromonDisplayP2 = [Value2dDisplay createBegin: self];
  [feromonDisplayP2 setDisplayWidget: worldP2Raster colormap: colorMap];
  [feromonDisplayP2 setDiscrete2dToDisplay: [model getFeromonP2]];
  [feromonDisplayP2 setDisplayMappingM: 512 C:0];
  feromonDisplayP2 = [feromonDisplayP2 createEnd];

  feromonDisplayF = [Value2dDisplay createBegin: self];
  [feromonDisplayF setDisplayWidget: worldFRaster colormap: colorMap];
  [feromonDisplayF setDiscrete2dToDisplay: [model getFeromonF]];
  [feromonDisplayF setDisplayMappingM: 512 C:0];
  feromonDisplayF = [feromonDisplayF createEnd];

  antDisplay = [Object2dDisplay createBegin: self];
  [antDisplay setDisplayWidget: worldRaster];
  [antDisplay setDiscrete2dToDisplay: [model getWorld]];
  [antDisplay setObjectCollection: [model getAntList]];
  [antDisplay setDisplayMessage:M(drawSelfOn:)];
  antDisplay = [antDisplay createEnd];

  [worldRaster setButton: ButtonRight
                  Client: antDisplay
                 Message: M(makeProbeAtX:Y:)];


  foodGraph = [EZGraph createBegin: globalZone];
  SET_WINDOW_GEOMETRY_RECORD_NAME (foodGraph);
  [foodGraph setGraphics: 1];
  [foodGraph setTitle: "Amount of food / time"];
  [foodGraph setAxisLabelsX:"Time" Y:"Amount of Food"];
  foodGraph = [foodGraph createEnd];

//  [foodGraph setFileOutput: 1 ];    // vystup EZGrafu do suboru
//  [foodGraph setFileName:"output.grp"];
  [foodGraph createSequence: "amount"
		  withFeedFrom: [model getFeromonF]
		  andSelector: M(getAmount)];   


  return self;
}

-buildActions
{
  [super buildActions];

  [model buildActions];

  displayActions = [ActionGroup create:self];

  [displayActions createActionTo: arenaDisplay  message:M(display)];
  [displayActions createActionTo: antDisplay   message:M(display)];
  [displayActions createActionTo: feromonDisplayP0 message:M(display)];
  [displayActions createActionTo: feromonDisplayP1 message:M(display)];
  [displayActions createActionTo: feromonDisplayF message:M(display)];
  [displayActions createActionTo: feromonDisplayP2 message:M(display)];
  [displayActions createActionTo: worldRaster  message:M(drawSelf)];
  [displayActions createActionTo: worldP1Raster  message:M(drawSelf)];
  [displayActions createActionTo: worldP0Raster  message:M(drawSelf)];
  [displayActions createActionTo: worldP2Raster  message:M(drawSelf)];
  [displayActions createActionTo: worldFRaster  message:M(drawSelf)];
  [displayActions createActionTo: foodGraph   message: M(step)];
  [displayActions createActionTo: foodGraph   message: M(outputToFile)];

  [displayActions createActionTo: actionCache message:M(doTkEvents)];
  [displayActions createActionTo: probeDisplayManager message:M(update)];

  displaySchedule = [Schedule createBegin: self];
  [displaySchedule setRepeatInterval: frDisp];
  displaySchedule = [displaySchedule createEnd];
  [displaySchedule at: 0 createAction: displayActions];

  return self;
}

-activateIn: swarmContext
{
  [super activateIn: swarmContext];

  [model activateIn: self];	

  [displaySchedule activateIn: self];

  return [self getSwarmActivity];

}

@end
